
'''
Funkce vypise vsechna prvocisla mensi nez nebo rovna zadanemu cislu n
n - priroze cislo
return - pole prvocisel mensich nebo rovno zadanemu cislu
'''
def eratosthenesovo_sito(n):
    # vytvoreni pole o n + 1 prvcich inicializovanych na true
    is_prime = [True] * (n + 1)
    is_prime[0] = is_prime[1] = False

    # pro kazde prvocislo od 2 do odmocniny z n odstranime z naseho pole nasobky tohoto prvocisla
    for p in range(2, int(n**0.5) + 1):
        if is_prime[p]:
            # zaciname na p*p protoze mensi nasobky p uz byly odstraneny v predeslych iteracich
            for i in range(p * p, n + 1, p):
                is_prime[i] = False

    # vytvoreni pole bez prvku oznacenych false
    primes = [p for p in range(2, n + 1) if is_prime[p]]

    return primes


print("Program Sieve - umoznuje zadani prirozeneho cisla a vypise vsechna prvocisla mensi nebo rovna zadanemu cislu")

n = int(input("Zadej prirozene cislo\n>"))
prime_numbers = eratosthenesovo_sito(n)
print("\nPrvocisla mensi nebo rovna zadanemu cislu jsou:")
print(prime_numbers)


input()
