# ----------------------------------------------------------------------------------------------------------
# autor: Dominik Vladar
# orion login: vladar21
# e-mail: vladar21@students.zcu.cz
#
# Program resi problem hledani prvocisel na stanovenem intervalu pomoci algoritmu
# Eratosthenova sita (zadani ze 4. cviceni, 2. cast).
# ----------------------------------------------------------------------------------------------------------

def get_prime_numbers(ceil):
    if ceil < 1:
        return []
    if ceil == 1:
        return []
    if ceil == 2:
        return [2]
    # cislo je kandidatem na prvocislo, pokud prime_candidates[cislo] == True
    prime_candidates = [False, False, True] + [True, False] * int(ceil/2 - 1)
    if len(prime_candidates) == ceil:
        prime_candidates.append(True)  # pokud ceil je liche cislo, musime jeden prvek pridat
    for i in range(3, int(ceil**0.5+1)):
        if prime_candidates[i]:
            for j in range(2*i, ceil, i):
                prime_candidates[j] = False

    prime = []

    for index, elem in enumerate(prime_candidates):
        if elem:
            prime.append(index)
    return prime


# Spusteni programu. Zde se definuje neserazeny seznam, nad kterym je
# pote volana funkce quick_sort.
if __name__ == '__main__':
    try:
        max_number = int(input("Jakym cislem (vcetne) chcete omezit hledani prvocisel? "))
        prime_numbers = get_prime_numbers(max_number)
        print("Na intervalu <1, {}> byla nalezena tato prvocisla: {}."
              .format(max_number, prime_numbers))
    except ValueError:
        print("Prosim, zadejte vstup odpovidajici celemu cislu.")
    input("Ukoncete stiskem klavesy ENTER.")
