"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-10-23
Program: Knihovna s funkci eratosthenea
Verze: 1.0.0
"""

# najde prvocisla
def eratosthenes(n):
    # vysledek pro cislo mensi nez 2
    if n < 2:
        return []
    # vytvorime pole o velikosti n + 1
    is_prime = [True] * (n + 1)
    # 0 a 1 nejsou prvocisla
    is_prime[0] = is_prime[1] = False

    # projdeme pres mozne prvocisla
    for x in range(2, int(n**0.5) + 1):
        if is_prime[x]:
            # vsechna cisla y, ktera jsou nasobkem x nejsou prvocislem
            for y in range(x + x, n + 1, x):
                is_prime[y] = False
    # vysledek
    primes = [x for x in range(2, n + 1) if is_prime[x]]
    return primes
