"""
@author Vitaliy Bohera
@version 1
@info Implementace algoritmu razeni quickSort
"""


"""
algoritmus quickSort s vyuzitim rekurze
@param array pole ktere mame seradit
"""
def quickSort(array):

    if len(array) <= 1:     # zastavovaci pominka rekurze, kdyz delka pole je mensi nebo rovna 1
        return array

    pivot = array[0]        # nastavim pivota jako prvni prvek v poli

    left = [x for x in array[1:] if x <= pivot]     # seznam cisel mensich nebo rovnych nez pivot
    right = [x for x in array[1:] if x > pivot]     # seznam cisel vetsich nez pivot
    sorted = quickSort(left) + [pivot] + quickSort(right)      # spojim seznamy
                                                               # a rekurzivne zavolam quickSort na levy a pravy seznam
    return sorted


# funkce vytvori pole a spusti nad nim algoritmus razeni quicksort
def main():
    array = [1, 3, -5, 2, 15, 35, -2, 5, 6, 2, -100, 2, -5, 0]
    print("Unsorted array:")
    print(array)

    sortedArray = quickSort(array)

    print('Sorted array in ascending order:')
    print(sortedArray)


if __name__ == '__main__':
    main()
