"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: October 10, 2023,
Description: This program sorts array with quicksort.
"""

def quicksort(array):
    """
    Sorts a list using the quicksort algorithm.
    :param array: The list to be sorted.
    :return: The sorted list.
    """
    if len(array) <= 1:
        return array

    pivot = array[len(array) // 2]
    left = [x for x in array if x < pivot]
    middle = [x for x in array if x == pivot]
    right = [x for x in array if x > pivot]

    return quicksort(left) + middle + quicksort(right)


if __name__ == "__main__":
    unsorted_list = [3, 6, 8, 10, 1, 2, 1, 4, 8, 3, 4, -6, 0, 11, 7]
    sorted_list = quicksort(unsorted_list)
    print("Unsorted List:", unsorted_list)
    print("Sorted List:", sorted_list)
