"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: October 10, 2023
Version: 1.0
Description: This program will print primary numbers with sieve_of_eratosthenes algorithm
"""


def sieve_of_eratosthenes(number):
    """
    Algorithm for finding primary numbers - sieve of eratosthenes
    :param number: Maximal possible value of number.
    :return:
    """
    sieve = [True] * number

    for x in range(2, number):
        if sieve[x]:
            for y in range(x * x, number, x):
                sieve[y] = False
    # adding primary numbers to array
    primary_numbers = []
    for x in range(2, number):
        if sieve[x]:
            primary_numbers.append(x)
    return primary_numbers


if __name__ == "__main__":
    user_input = input("Enter the number into which the primary numbers will be searched: ")
    try:
        user_number = int(user_input)
    except ValueError:
        print("Invalid input. Please enter a valid number.")
    array_of_primary_numbers = sieve_of_eratosthenes(user_number)
    # formatting array
    formatted_array = ', '.join([str(primary_number) for primary_number in array_of_primary_numbers])
    print("The primary numbers to {} are: {}".format(user_number, formatted_array))
